Xapian: API Documentation: Xapian::DateRangeProcessor Class Reference

Public Member Functions | List of all members
Xapian::DateRangeProcessor Class Reference

Handle a date range. More...

Inheritance diagram for Xapian::DateRangeProcessor:
[legend]

## Public Member Functions
| DateRangeProcessor (Xapian::valueno slot_, unsigned flags_=0, int epoch_year_=1970)
| Constructor. More...
| DateRangeProcessor (Xapian::valueno slot_, const std::string &str_, unsigned flags_=0, int epoch_year_=1970)
| Constructor. More...
Xapian::Query | operator() (const std::string &begin, const std::string &end)
| Check for a valid date range. More...
Public Member Functions inherited from Xapian::RangeProcessor
| RangeProcessor ()
| Default constructor. More...
| RangeProcessor (Xapian::valueno slot_, const std::string &str_=std::string(), unsigned flags_=0)
| Constructor. More...
virtual | ~RangeProcessor ()
| Destructor.
Xapian::Query | check_range (const std::string &b, const std::string &e)
| Check prefix/suffix on range. More...
RangeProcessor * | release ()
| Start reference counting this object. More...
const RangeProcessor * | release () const
| Start reference counting this object. More...

## Additional Inherited Members
Protected Attributes inherited from Xapian::RangeProcessor
Xapian::valueno | slot
| The value slot to process. More...
std::string | str
| The prefix (or suffix with RP_SUFFIX) string to look for. More...
unsigned | flags
| Flags. More...

## Detailed Description

Handle a date range.

Begin and end must be dates in a recognised format.

## Constructor & Destructor Documentation

## ◆ DateRangeProcessor() [1/2]

Xapian::DateRangeProcessor::DateRangeProcessor | ( | Xapian::valueno | slot_,
|  | unsigned | flags_ = `0`,
|  | int | epoch_year_ = `1970`
| ) |  |
| inlineexplicit

Constructor.

Parameters

  slot_ | The value number to return from operator().
  flags_ | Zero or more of the following flags, combined with bitwise-or: Xapian::RP_DATE_PREFER_MDY - interpret ambiguous dates as month/day/year rather than day/month/year.
  epoch_year_ | Year to use as the epoch for dates with 2 digit years (default: 1970, so 1/1/69 is 2069 while 1/1/70 is 1970).

## ◆ DateRangeProcessor() [2/2]

Xapian::DateRangeProcessor::DateRangeProcessor | ( | Xapian::valueno | slot_,
|  | const std::string & | str_,
|  | unsigned | flags_ = `0`,
|  | int | epoch_year_ = `1970`
| ) |  |
| inline

Constructor.

Parameters

  slot_ | The value slot number to query.
  str_ | A string to look for to recognise values as belonging to this date range.
  flags_ | Zero or more of the following flags, combined with bitwise-or: Xapian::RP_SUFFIX - require str_ as a suffix instead of a prefix. Xapian::RP_REPEATED - optionally allow str_ on both ends of the range - e.g. $1..$10 or 5m..50m. By default a prefix is only checked for on the start (e.g. date:1/1/1980..31/12/1989), and a suffix only on the end (e.g. 2..12kg). Xapian::RP_DATE_PREFER_MDY - interpret ambiguous dates as month/day/year rather than day/month/year.
  epoch_year_ | Year to use as the epoch for dates with 2 digit years (default: 1970, so 1/1/69 is 2069 while 1/1/70 is 1970).

The string supplied in str_ is used by operator() to decide whether the pair of strings supplied to it constitute a valid range. If prefix_ is true, the first value in a range must begin with str_ (and the second value may optionally begin with str_); if prefix_ is false, the second value in a range must end with str_ (and the first value may optionally end with str_).

If str_ is empty, the Xapian::RP_SUFFIX and Xapian::RP_REPEATED are irrelevant, and no special strings are required at the start or end of the strings defining the range.

The remainder of both strings defining the endpoints must be valid dates.

For example, if str_ is "created:", Xapian::RP_SUFFIX is not specified, and the range processor has been added to the queryparser, the queryparser will accept "created:1/1/2000..31/12/2001".

## Member Function Documentation

## ◆ operator()()

Xapian::Query Xapian::DateRangeProcessor::operator() | ( | const std::string & | begin,
|  | const std::string & | end
| ) |  |
| virtual

Check for a valid date range.

If any specified prefix is present, and the range looks like a date range, the dates are converted to the format YYYYMMDD and combined into a value range query.

Parameters

  begin | The start of the range as specified in the query string by the user.
  end | The end of the range as specified in the query string by the user.

Reimplemented from Xapian::RangeProcessor.

The documentation for this class was generated from the following file:

- xapian/queryparser.h